Description

User story 1: Joe has a multicore processor but when QGIS  is rendering a map, one of the cores is heavily utilised whilst the rest remain

idle.

User story 2: Pam wishes she didnt need to wait so long for maps to draw as each layer draw carries out a long running query against a

database backend.

Qt4 includes QThread which makes writing multithreaded cross platform libraries fairly easily. Thus it would be good to start thinking

about how we can make QGIS take advantage of this.

In my mind there are two main areas of work required:

    -  making map layers inherit from QThread and adding in sufficient foundation for them to be able to render in a thread (pretty much

covered in the attached patch).

    -  Updating qgsmaprenderer.cpp to orchestrate the threaded rendering of map layers and the composition of the results.

For the second (renderer part) we will need to split the render process into three parts I think:

    -  a setup phase which sets the render context for each maplayer (which would need to become a member of qgsmaplayer) and then

calls the run() method to launch the thread

    -  a slot to listen for when each thread is done and tally up when all the rendering work is completed

    -  a finalise method to end the render process with label and acetate rendering and perform final compositing from layer render cache

images.

Related issues:

Related to QGIS Application - Bug report # 8889: Slow "selection" of features Closed 2013-10-17

History

#1 - 2009-10-29 12:58 AM - Marco Hugentobler

Hi Tim

Please also consider the [[QtConcurrent]] (http://doc.trolltech.com/4.5/threads.html#qtconcurrent) framework as an option. The advantage over inheritance

from QThread is that the number of created threads automatically adapts depending on the number of cores. Furthermore it is more high-level and

therefore simpler to use. And it does not require api changes in [[QgsMapLayer]].

The Qt doc about [[QtConcurrent]] is not as good as the usual Qt docs. I once wrote an example to render a tiled raster in threads with [[QtConcurrent]]. We

may look at this next week.

cheers,

Marco
#2 - 2009-11-03 02:26 AM - Martin Dobias

I'd like to second Marco's suggestion. Inheriting map layers from QThread looks like a bad design decision...

#3 - 2010-06-11 11:16 PM - Paolo Cavallini

There is an ongoing Summer of Code project dealing with this. Hopefully we'll see the results in a couple of months

#4 - 2011-11-23 06:01 PM - Aren Cambre

- Assignee deleted (nobody -)

- Operating System deleted (Debian)

- Pull Request or Patch supplied set to No

Has anything come of this?

#5 - 2011-12-16 01:58 PM - Giovanni Manghi

- Target version changed from Version 1.7.0 to Version 1.7.4

#6 - 2012-01-11 07:32 PM - Aren Cambre

Oh, wow, this will really come with 1.7.4?

#7 - 2012-01-11 07:36 PM - Nathan Woodrow

- Target version changed from Version 1.7.4 to Version 2.0.0

No.  I would say that last update was a mistake.

2.0 would be the best target as I haven't seen much work on this in a while.

#8 - 2012-01-11 07:36 PM - Aren Cambre

OK, thanks. This would be an exciting improvement. Is "low" priority really correct?

#9 - 2012-10-06 02:23 AM - Pirmin Kalberer

- Target version changed from Version 2.0.0 to Future Release - Nice to have

#10 - 2013-06-28 02:54 PM - Aren Cambre

I'm surprised this remains low priority. This would be a huge benefit for complex maps.

#11 - 2013-06-28 04:10 PM - Nathan Woodrow

It's not really low as Martin is planning to work on it after 2.0.
#12 - 2013-06-28 06:57 PM - Aren Cambre

- Priority changed from Low to Normal

#13 - 2014-02-13 05:50 PM - Tim Sutton

- Status changed from Open to Closed

I'm closing this out - Martin Dobias has an implementation in a branch which will be merged post QGIS 2.2

Files

qgis_threaded_render.v1.diff 4.55 KB 2009-10-27 Tim Sutton
